/*
 Copyright 2005 GuruNet Corp
 Some portions of this code are Copyright (c) 2005 Sean Billig. For complete copyright information see Main2.js
*/

var hostArr = new Array();
hostArr["danielb"] = new Array("http://danielb-ws:8080", "/answers/main/ntquery?s=", "&gwp=17");
hostArr["lac"] = new Array("http://lac", "/", "?gwp=17");
hostArr["stage1"] = new Array("http://stage1.answers.com", "/", "?gwp=17");
hostArr["answers"] = new Array("http://www.answers.com", "/", "?gwp=17");

var host = hostArr["answers"][0];
var qPath = hostArr["answers"][1];
var gwp = hostArr["answers"][2];

var gnurl="http://www.gurunet.com";
var answerMarkerStart = "<answermarker>";
var answerMarkerEnd = "</answermarker>";
var flipper;

var isWebKit = navigator.userAgent.indexOf('AppleWebKit') > -1;

function loaded() {
    flipper = new Fader(document.getElementById('flip'), null, 500);
    document.getElementById('content').innerHTML = "";
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));

    historyArray = new Array();
    historyCount = 0;
    historyPointer = 0;

//    if (window.widget) { userName = widget.system("echo $USER", null).outputString.replace(/\n/, '');    }
	
    currentVersion = getKeyValue("Info.plist", "CFBundleVersion");
	document.getElementById('versionNumber').innerHTML = currentVersion;
//alert("currentVersion = " + currentVersion);
	    calculateAndShowThumb(document.getElementById('content'));
	setInterval("calculateAndShowThumb(document.getElementById('content'))", 4000);

}

function showBackside(event) {
	if (window.widget) {
		window.widget.prepareForTransition("ToBack");
	}

    document.getElementById('fliprollie').style.display='none';
    document.getElementById('front').style.display='none';
    document.getElementById('parentDiv').style.display='none';
    document.getElementById('searchBar').style.display='none';
    document.getElementById('answersLogo').style.display='none';
    document.getElementById('back').style.display='block';
    document.getElementById('doneButton').src = "Images/done.png";

	if (window.widget) {
		setTimeout("window.widget.performTransition()", 0);
	}
}

function showFront(event) {
	if (window.widget) {
		window.widget.prepareForTransition("ToFront");
	}
    document.getElementById('back').style.display='none';

    document.getElementById('front').style.display='block';
    document.getElementById('parentDiv').style.display='block';
    document.getElementById('answersLogo').style.display='block';
    document.getElementById('searchBar').style.display='block';

	if (window.widget) {
		setTimeout("window.widget.performTransition()", 0);
	}
}

function openInBrowser() {
	if (window.widget)
	    widget.openURL(host);
	else
		window.open(host);
}

var req;
var type;
function processQuery(s, _type, fromHistory) {
	if (s == "")
		return;
	if (!isWebKit) {
		netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
	}

	type = _type;

    if (!fromHistory) {
		var search = new HistoryObject(s, _type);
		addToHistory(search);
}

	if (s.indexOf("cmd:sethost=") == 0)	{
		hostname = s.slice(12);
		if (!hostArr[hostname]) alert("invalid host");
		else {
			host = hostArr[hostname][0];
			qPath = hostArr[hostname][1];
			gwp = hostArr[hostname][2];
		}
		alert("host = " + host + ", qPath = " + qPath + ", gwp = " + gwp);
		return;
    } else {
		if (type && type=="ilnk") {
			url = s;
		} else {
			searchWithPluses = encodeURIComponent(s);
			url = host + qPath + searchWithPluses + gwp + "&ver=" + currentVersion;
		}
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", url ,true);
        req.send(null);
	}
}

function processReqChange() {
    // only if req shows "loaded"
    if (req.readyState == 4) {
	    results = "";
        // only if "OK"
//        if (req.status == 200) { // don't check this. Sometimes status is undefined!?

			response = req.responseText;

			if (type && type=="ilnk") {
				re = /<meta name=\"TopicName\" content=\"([^"]+)\">/;
				if (re.test(response))
					document.getElementById("searchInput").value = RegExp.$1;
			}

			resultsIndex = response.indexOf(answerMarkerStart);
			if (resultsIndex > -1) {
				start = resultsIndex + answerMarkerStart.length;
				end = response.indexOf(answerMarkerEnd) + answerMarkerEnd.length;
				results = response.substring(start, end);
			}
			if (window.widget) {
				pat = /window\.open\(([^"'\s,)]+)\)/g;
				results = results.replace(pat, "widget.openURL($1)");
				pat = /window\.open\((['"][^"']+["'])[^)]*\)/g;
				results = results.replace(pat, "widget.openURL($1)");
			}
			pat = /playIt\s*\((\'.+?\')\)/g ;
			results = results.replace(pat, "if(window.widget)widget.openURL($1); else window.open($1)");

			if (document.getElementById("serverscript1")) {
				// we've already got it, don't let webkit add it again
				pat = /<link[^>]+ id=\"serverscript1\".*?>/;
				results = results.replace(pat, "");
			}
			if (results.length < 20) {
				results = '<p><b>No results available. There seems to be a problem connecting to ' + host + '.</b></p>';
			}
//		}

		contentDiv = document.getElementById('content');
		contentDiv.innerHTML = results;
		Atags = contentDiv.getElementsByTagName("A");
		for (i=0;i<Atags.length;i++) {
			el = Atags[i];
			href = el.href;
			if (href.indexOf("http") != 0) {
//				alert("el = " + el + ", el.pathname = " + el.pathname);
				href = host + (el.pathname ? el.pathname : "") + (el.search ? el.search : "");
			}
			if (el.className == "ilnk") {
				href += (href.indexOf('?') > -1 ? "&gwp=17" : "?gwp=17") + (el.hash != "#" ? el.hash : "");
				el.href="javascript:processQuery('" + href + "', 'ilnk')";
			}
			else {
				if (href.indexOf("transoptform") > -1)
					href += (href.indexOf("?") > -1) ? "&gwp=8" : "?gwp=8";
				href = href.replace(/gwp([=-])17/, "gwp$18") + (el.hash != "#" ? el.hash : "");
				el.href = "javascript:" + (window.widget ? "widget.openURL" : "window.open") + "('" + href + "')";
			}
		}
		currentContent.style.top = '0px';
		calculateAndShowThumb(contentDiv);
	}
}

function collapse() {
		contentDiv = document.getElementById('content');
		contentDiv.innerHTML = "";
		currentContent.style.top = '0px';
		calculateAndShowThumb(contentDiv);
}

/*
*   Window resizing
*/

var lastPos;
function mouseDown(event)
{
    var x = event.x + window.screenX;
    var y = event.y + window.screenY;

    document.addEventListener("mousemove", mouseMove, true);
    document.addEventListener("mouseup", mouseUp, true);
    lastPos = {x:x, y:y};
    event.stopPropagation();
    event.preventDefault();
}
function mouseMove(event)
{
    var screenX = event.x + window.screenX;
    var screenY = event.y + window.screenY;

    var deltaX = 0;
	var deltaY = 0;

    if ( (window.innerWidth + (screenX - lastPos.x)) >= 455 ) {
        deltaX = screenX - lastPos.x;
        lastPos.x = screenX;
    }
    if ( (window.innerHeight + (screenY - lastPos.y)) >= 250 ) {
		deltaY = screenY - lastPos.y;
		lastPos.y = screenY;
	}

    document.getElementById('front').style.width = parseInt(document.getElementById('front').style.width) + deltaX;
    document.getElementById('front').style.height = parseInt(document.getElementById('front').style.height) + deltaY;
    window.resizeBy(deltaX, deltaY);
    calculateAndShowThumb(document.getElementById('content'));
    event.stopPropagation();
    event.preventDefault();
}
function mouseUp(event)
{
    window.resizeTo(parseInt(document.getElementById('front').style.width), parseInt(document.getElementById('front').style.height));
    document.removeEventListener("mousemove", mouseMove, true);
    document.removeEventListener("mouseup", mouseUp, true);
    event.stopPropagation();
    event.preventDefault();
}
